var input = "marktsreyesiaaaa";
var grid = [['a','a','a','a'],['a','a','a','a'],['a','a','a','a'],['a','a','a','a']];

var tree = JSON.parse('{"e":{"s":{"w":true}},"a":{"a":{"w":true},"r":{"k":{"w":true}}},"m":{"a":{"r":{"k":{"w":true,"e":{"r":{"w":true,"s":{"w":true}}}}}}},"y":{"e":{"s":{"w":true}}}}');

$(document).ready(function(){
    // are we running in native app or in a browser?
    window.isphone = false;
    if(document.URL.indexOf("http://") === -1 
        && document.URL.indexOf("https://") === -1
        && document.URL.indexOf("file://") === -1
        && document.URL.indexOf("localhost") === -1) {
        window.isphone = true;
	}

    if( window.isphone ) {
        document.addEventListener("deviceready", onDeviceReady, false);
    } else {
        onDeviceReady();
    }
});

var dataAll;

function storeWord(t, word) {
	var index, ch, entry;

	for (index = 0; index < word.length; ++index) {
		ch = word.charAt(index);
		entry = t[ch];
		if (!entry) {
			t[ch] = entry = {};
		}
		t = entry;
	}
	t.w = true;
}

function onDeviceReady(){
	// loadDictionary();
	$( "#frm" ).submit(function( event ) {
		event.preventDefault();
		defineboard();
	});
	
	var divWidth = $('#board_div').width();
	$('#board_div').height(divWidth);	
	$(window).resize(function(){
		$('#board_div').height(divWidth);
	});
}

function loadDictionary(){
	$.get('words2.txt', function(data) { 
		dataAll = data;
		console.log(dataAll);
		var lines = data.split("\n");

		$.each(lines, function(n, word) {
			//console.log("storing word "+word);
		   	storeWord(tree, word);
		});
		console.log(tree);
	});
}



function set_board_size() {
    var bs = dimension;
    if (bs) {
        dimension = parseInt(bs.value);
        board = new Array();
        board.length = dimension * dimension;
    }
}

function maketable(firsttime) {
    var s = '';
    var i, j;
    for (i = 0; i < dimension; i++) // here? 1
    {
        for (j = 0; j < dimension; j++) {
            s = s + '<div class="matrixcell" id="' + i + '_' + j + '">*</div>';
        }
		s = s + "<br>";
    }
    if (firsttime) {
        document.writeln(s);
    } else {
        $('#board_div').html(s);
    }
}

function updatetable() {
    var i, j;
    for (i = 0; i < dimension; i++) // here? 2
    {
        for (j = 0; j < dimension; j++) {
            var c = board[i + j * dimension].toUpperCase();
            if (c == 'Q') c = 'Qu';
            document.getElementById(i + '_' + j).innerHTML = c;
        }
    }
}



function defineboard() {
    var b = document.getElementById('boarddef').value.toLowerCase();
    if (b.length == dimension * dimension) {
        var i, j, k = 0;
        for (i = 0; i < dimension; i++) {
            for (j = 0; j < dimension; j++) {
                board[i + j * dimension] = b.charAt(k);
                k += 1;
            }
        }
        console.log(board);
        updatetable();
		
        showsolution();
    }
}

function transform_word(word) {
    var w = word.toUpperCase();
    return w.replace(/Q/g, 'Qu');
}

function showsolution() {
    solve();
	$('#solution').html("");
    for (var wl = dimension*dimension; wl >= 3; wl--) {
        for (var i = 0; i < solutions.length; i++) {
            if (solutions[i].length == wl) {
				$('#solution').append("<div class=\"answer\">"+transform_word(solutions[i])+"</div>");
            }
        }

    }

}

function solve() {
    var minlength = 3;
    solutions = new Array();
    for (var i = 0; i < words.length; i++) {
        if (words[i].length >= minlength) {
            if (findword(words[i])) {
                solutions.push(words[i]);
            }
        }
    }
    updatetable();
}

function findword(word) {
    if (word.length == 0) return 0;
    var i, j;
    for (i = 0; i < dimension; i++) {
        for (j = 0; j < dimension; j++) {
            if (board[i + j * dimension] == word.charAt(0)) {
                if (findsequence(word, i, j)) return 1;
            }
        }
    }
    return 0;
}

function safeboard(i, j) {
    if ((i < 0) || (j < 0) || (i >= dimension) || (j >= dimension)) return '*';
    return board[i + j * dimension];
}

function findsequence(seq, i, j) {
    if (seq.length <= 1) return 1;
    var s;
    s = board[i + j * dimension];
    board[i + j * dimension] = ' ';
    for (var u = -1; u <= 1; u = u + 1) {
        for (var v = -1; v <= 1; v = v + 1) {
            if (safeboard(i + u, j + v) == seq.charAt(1)) {
                if (findsequence(seq.substr(1), i + u, j + v)) {
                    board[i + j * dimension] = s;
                    return 1;
                }
            }
        }
    }
    board[i + j * dimension] = s;
    return 0;
}

dimension = 4;
bar_width = 368;
totaltime = 10 * 1000;
updatefrequency = 50;
numsolutioncols = 4;


board = new Array();
board.length = dimension * dimension;



function storeLocal(key, value){
	window.localStorage.setItem(key, value);
}

function retrieveLocal(key){
	if (window.localStorage.getItem(key) == null)
	{
		if (key == "lastCityID")
			storeLocal("lastCityID", 0);
		else if (key == "citiesAll")
			storeLocal("citiesAll", '{"data":[]}');
	}
	return value = window.localStorage.getItem(key);
}